package jp.co.opentone.servlet;

import java.io.IOException;
import java.security.cert.X509Certificate;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.opentone.bean.CertInfo;
import jp.co.opentone.util.CertUtil;


/**
 * NCAgF،oRŃANZXĂ[U[̏ؖ\T[ubg
 * @author thatanaka
 */
 public class ShowClientCertServlet extends javax.servlet.http.HttpServlet implements javax.servlet.Servlet {
	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}  	
	
	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}
	
	/**
	 * 擾NCAgؖ̓e擾B
	 * @param request
	 * @param response
	 * @throws ServletException
	 * @throws IOException
	 */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException
	{
    	// ZLAȒʐM(https)ǂ`FbNB
    	if (!request.isSecure()) {
    		throw new ServletException("Secure is false !!!");
    	}
    	
    	CertInfo info = null;
	    // ؖ̎擾
        X509Certificate[] certs = (X509Certificate[])
	        	request.getAttribute("javax.servlet.request.X509Certificate");
	    if(certs != null) {
	    	// NCAgؖ̎擾
	        X509Certificate clientCert = certs[0];
	        if(clientCert != null) {
	        	info = CertUtil.createCertInfo(clientCert);
		    	// ̖ؖ擾
		    	info.setCertNum(certs.length);
	        }
	    } else {
	    	// ؖ񂪎擾łȂO
	    	throw new ServletException("X509Certificate is null !!!");
	    }
	    // ؖ̃Zbg
	    request.setAttribute("info", info);
	    
	    getServletContext().getRequestDispatcher("/showcert.jsp").forward(request, response);
	}
}